Although this whole package is pointless without Matlab (a large non-free
something) the source package has been placed into 'main' for the following
reason:

It builds a 'matlab-support-dev' package that other source packages can build
depend on to figure out where to install MEX sources and M-files (analogous to
the way Octave packages provide this information via a Makefile snippet). This
-dev package has nothing to do with Matlab and should go into 'main', as
otherwise no source package that build-depends on it could go into 'main'.
That would be suboptimal for otherwise DFSG-compliant package that simply also
_can_ build MEX extensions (e.g. see the dynare-matlab package in the archive).

The actual Matlab adaptor package is placed into 'contrib'.
